(require 'make-theme)

(let
    ((patterns-alist
      '(("bottom-right"
         (inactive
          "A_b_corner_br1.png")
         (focused
          "A_b_corner_H_br1.png"))
        ("bottom-left"
         (inactive
          "A_b_corner_bl1.png")
         (focused
          "A_b_corner_H_bl1.png"))
        ("hbar"
         (inactive
          "hbar.png"
          (border
           2
           2
           2
           2)))
        ("vbar"
         (inactive
          "vlbar.png"
          (border
           2
           2
           2
           2)))
        ("close"
         (inactive
          "button_kill_1.png")
         (focused
          "b_kill_1.png")
         (highlighted
          "button_kill_2.png")
         (clicked
          "button_kill_3.png"))
        ("title"
         (inactive
          "A_b_title1.png"
          (border
           4
           4
           4
           4))
         (focused
          "A_b_title3.png"
          (border
           4
           4
           4
           4)))
        ("menu"
         (inactive
          "button_iconify_1.png")
         (focused
          "b_iconify_1.png")
         (highlighted
          "button_iconify_2.png")
         (clicked
          "button_iconify_3.png"))))

     (frames-alist
      '(("normal"
         ((top-edge . -16)
          (left-edge . 1)
          (background . "menu")
          (class . menu-button))
         ((right-edge . 18)
          (left-edge . 18)
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (background . "title")
          (top-edge . -16)
          (class . title))
         ((top-edge . -16)
          (right-edge . 1)
          (background . "close")
          (class . close-button))
         ((left-edge . -2)
          (top-edge . -16)
          (bottom-edge . 16)
          (background . "vbar")
          (class . left-border))
         ((right-edge . -2)
          (bottom-edge . 16)
          (class . right-border)
          (background . "vbar")
          (top-edge . -16))
         ((right-edge . 15)
          (left-edge . 15)
          (bottom-edge . -2)
          (background . "hbar")
          (class . bottom-border))
         ((left-edge . -2)
          (bottom-edge . -2)
          (background . "bottom-left")
          (class . bottom-left-corner))
         ((right-edge . -2)
          (bottom-edge . -2)
          (background . "bottom-right")
          (class . bottom-right-corner)))
        ("shaped"
         ((top-edge . -16)
          (left-edge . -2)
          (background . "menu")
          (class . menu-button))
         ((right-edge . 17)
          (left-edge . 17)
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (background . "title")
          (top-edge . -16)
          (class . title))
         ((top-edge . -16)
          (right-edge . -2)
          (background . "close")
          (class . close-button)))
        ("transient"
         ((right-edge . -2)
          (top-edge . -16)
          (left-edge . -2)
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (background . "title")
          (class . title))
         ((left-edge . -2)
          (top-edge . 3)
          (bottom-edge . 17)
          (background . "vbar")
          (class . left-border))
         ((class . right-border)
          (background . "vbar")
          (bottom-edge . 17)
          (top-edge . 3)
          (right-edge . -2))
         ((bottom-edge . -2)
          (right-edge . 18)
          (left-edge . 18)
          (background . "hbar")
          (class . bottom-border))
         ((background . "bottom-left")
          (bottom-edge . -2)
          (left-edge . -2)
          (class . bottom-left-corner))
         ((bottom-edge . -2)
          (right-edge . -2)
          (background . "bottom-right")
          (class . bottom-right-corner)))
        ("shaped-transient"
         ((right-edge . -2)
          (top-edge . -16)
          (left-edge . -2)
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (background . "title")
          (class . title)))
        ("nil")))

     (mapping-alist
      '((default . "normal")
        (transient . "transient")
        (shaped . "shaped")
        (shaped-transient . "shaped-transient")
        (unframed . "nil")))

     (theme-name 'blasphemy))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))
